/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *	UART]
 *
 * \par Application note:
 *	AVR064: LCDo͕txĎ
 *
 * \par Documentation:
 *	IȺގAxׁ߲A߲אݒAx޲ɂĂreadme.html
 *	B
 *
 * \author
 *	Atmel Corporation: http://www.atmel.com \n
 *	xEҰ: avr@atmel.com
 *
 * $Name: RELEASE_1_1 $
 * $Revision: 1.3 $
 * $RCSfile: UART.c,v $
 * $Date: 2006/02/16 18:11:22 $  \n
 ******************************************************************************/

// ݸٰ ̧
#include "Main.h"
#include "UART.h"

// Sϐ
unsigned char RX_byte_nr;						// M޲Čv
unsigned char sPreamble[] = "STK502";			// ڰъJnopO
unsigned char ReceiveBuffer[50];				// Mޯ̧
unsigned char TransmitBuffer[50];				// Mޯ̧
unsigned char TX_byte_nr;						// M޲Ĉʒuw/v
unsigned char Bytes_to_send;					// M޲Đ
unsigned char RX_Packet_complete = FALSE;		// ߹ĎM׸
unsigned char RX_Preamble_complete = FALSE;		// ߹đOM׸
unsigned char Dec_L;							// 10i1̌l
unsigned char Dec_M;							// 10i10̌l
unsigned char Dec_H;							// 10i100̌l

/*! \brief	USART
 *  \param	BaudRate	- ްڰ(UBRR)wl
 */
void UART_init(unsigned char BaudRate)
{
  RX_byte_nr = 0;						// M޲Ĉʒuw/v평
  UBRR0L = BaudRate;					// ްڰĐݒ
  UCSR0A = (1<<U2X0);					// {싖
  UCSR0B = (1<<RXCIE0) | (1<<TXCIE0) | (1<<RXEN0) | (1<<TXEN0);		// M荞݋,M
  UCSR0C = (3<<UCSZ00);					// 8ޯ ް,èȂ,1~ޯĐݒ
}

/*! \brief	Mޯ̧ASCII2ilɕϊĊeϐ֐ݒ
 */
void Store_RX_data(void)
{
  unsigned char ASCII_Cnt = 0;			// Mޯ̧ ޲Ĉʒuw/v
  unsigned char HEX_Cnt = 0;			// ϐ޲Ĉʒuw/v
  unsigned char HEX_byte;				// 2iϊl

  while(RX_Packet_complete)				// ߹ĎMŁA
  {
	HEX_byte = 0;						// 2iϊl

	// q($20)ƏIq($0D)Ԃ̒l2ilϊ
	while((ReceiveBuffer[ASCII_Cnt] != 0x20) & (ReceiveBuffer[ASCII_Cnt] != 0x0D))
	{
	  HEX_byte *= 10;									// Ol~10
	  HEX_byte += (ReceiveBuffer[ASCII_Cnt] - '0');		// ޲Ă2ilZ
	  ASCII_Cnt++;										// Mޯ̧ ޲Ĉʒuw/vis
	}

	if(ASCII_Cnt)						// ϊlLŁA
	{
	  *(&HOUR + HEX_Cnt) = HEX_byte;	// Ήϐ֕ϊ2ili[
	  HEX_Cnt++;						// ϐ޲Ĉʒuw/vis
	}

	if(ReceiveBuffer[ASCII_Cnt] == 0x20)	// qȂA
	  ASCII_Cnt++;							// Mޯ̧ ޲Ĉʒuw/vis
	else									// IqȂA
	{
	  RX_Packet_complete = FALSE;			// ߹ĎM׸މ
	}
  }
}

/*! \brief	Mޯ̧ްM
 */
void Send_TX_data(void)
{
  unsigned char Nr_bytes_in_TX_buffer;
  unsigned char Cnt;
  unsigned char Nr_ASCII_bytes;

  if(!(UCSR0B & 0x20))					// USARTMłȂ΁A
  {
	Nr_bytes_in_TX_buffer = 0;			// Mޯ̧ ޲Ĉʒuw/v평
	while(sPreamble[Nr_bytes_in_TX_buffer])		// O𑗐Mޯ̧֐ݒ
	{
	  TransmitBuffer[Nr_bytes_in_TX_buffer] = sPreamble[Nr_bytes_in_TX_buffer];		// OΉ޲Ă𑗐Mޯ̧֕
	  Nr_bytes_in_TX_buffer++;			// Mޯ̧ ޲Ĉʒuw/vis
	}

	Cnt = 0;							// ϐ޲Ĉʒuw/v평
	while(Cnt < Nr_of_hex_bytes_to_send)				// ߹ēS޲Ċ܂Ōp
	{
	  TransmitBuffer[Nr_bytes_in_TX_buffer++] = 0x20;	// Mޯ̧ɕqݒ
	  Nr_ASCII_bytes = HEX2ASCII(*(&HOUR + Cnt++));		// Ή޲ASCIIϊ,ASCII޲Đ擾
	  while(Nr_ASCII_bytes)				// ASCII޲ĐMޯ̧֕
	  {
		Nr_ASCII_bytes--;				// ASCII޲Đ(0ʒuwq)
		TransmitBuffer[Nr_bytes_in_TX_buffer++] = *(&Dec_L + Nr_ASCII_bytes);	// ΉASCII޲Ă𑗐Mޯ̧֕
	  }
	}

	TransmitBuffer[Nr_bytes_in_TX_buffer++] = 0x20;			// Mޯ̧ɕqݒ
	TransmitBuffer[Nr_bytes_in_TX_buffer++] = REVISION_H;	// ԍ޲Ă𑗐Mޯ̧֐ݒ
	TransmitBuffer[Nr_bytes_in_TX_buffer++] = REVISION_L;	// ԍ޲Ă𑗐Mޯ̧֐ݒ
	TransmitBuffer[Nr_bytes_in_TX_buffer++] = 0x0D;			// Mޯ̧ɏIq(CR)ݒ
	TransmitBuffer[Nr_bytes_in_TX_buffer++] = 0x0A;			// Mޯ̧ɏIq(LF)ݒ
	TX_byte_nr = 0;											// M޲Ĉʒuw/v평
	Bytes_to_send = Nr_bytes_in_TX_buffer;					// M޲Đݒ

	UCSR0B |= (1<<UDRIE0);				// ް ڼ޽(UDRE)荞݋(MJn)
  }
}


/*! \brief	2i޲ā2,3޲Ă10iASCIIϊ
 *  \param  Hex	- ϊׂ2i޲Ēl
 *  \return 10iASCII޲Đ(Dec_L,Dec_M,(Dec_H))
 */
unsigned char HEX2ASCII(unsigned char Hex)
{
  unsigned char Nr_ASCII_bytes = 2;

  Dec_L = 0;				// 10i1̌l
  Dec_M = 0;				// 10i10̌l
  Dec_H = 0;				// 10i100̌l

  while(Hex)				// 팸0ȊOŁA10iASCIIϊ
  {
	Dec_L = Hex;			// 팸1̌lƂĐݒ(ŏÎݗL)
	Hex -= 10;				// 팸-10(10̌l쐬̂)
	if(!(SREG & 0x01))		// ذȂ(팸)ŁA
	{
	  Dec_M++;				// 10̌lis
	  if(Dec_M > 9)			// 10̌LŁA
	  {
		Dec_M = 0;			// 10̌l
		Dec_H++;			// 100̌lis
	  }
	  if(!Hex)				// c팸=0ŁA
		Dec_L = 0;			// 1̌l=0ݒ
	}
	else					// ذL(-10̌ʂ)ŁA
	  Hex = 0;				// 팸=0(I)ݒ
  }

  Dec_L += 0x30;			// 1̌l10iASCIIϊ
  Dec_M += 0x30;			// 10̌l10iASCIIϊ

  if(Dec_H)					// 100ȏŁA
  {
	Dec_H += 0x30;			// 100̌l10iASCIIϊ
	Nr_ASCII_bytes++;		// ASCII޲Đ3ɕύX
  }
  return Nr_ASCII_bytes;	// ASCII޲ĐƋɕA
}

/*! \brief	USART0M荞ٰ
 */
#pragma vector = USART0_RXC_vect
__interrupt void USART0_RXC_interrupt(void)
{
  unsigned char RX_byte;

  RX_byte = UDR0;			// M޲(UDR0)l擾

  if((RX_byte == sPreamble[RX_byte_nr]) & !RX_Preamble_complete)	// ȎΉvŁA
  {
	RX_byte_nr++;								// M޲Ĉʒuw/vis
	if(RX_byte_nr == (sizeof(sPreamble) - 1))	// OS޲ĊŁA
	{
	  RX_Preamble_complete = TRUE;				// ߹đOM׸ސݒ
	  RX_byte_nr = 0;							// M޲Ĉʒuw/v평
	}
  }
  else if(RX_Preamble_complete)					// ߹đOMŁA({M)
  {
	ReceiveBuffer[RX_byte_nr++] = RX_byte;		// M޲ĂMޯ̧Ήʒu֕,M޲Ĉʒuw/vis
	if(RX_byte == 0x0D)							// IqŁA
	{
	  ReceiveBuffer[RX_byte_nr++] = RX_byte;	// IqMޯ̧Ήʒu֕,M޲Ĉʒuw/vis
	  RX_Preamble_complete = FALSE;				// ߹đOM׸ޏ
	  RX_Packet_complete = TRUE;				// ߹ĎM׸ސݒ
	  RX_byte_nr = 0;							// M޲Ĉʒuw/v평
	}
  }
  else											// O̕svŁA
	RX_byte_nr = 0;			// M޲Ĉʒuw/v평
}

/*! \brief	USART0ް ڼ޽󂫊荞ٰ
 */
#pragma vector = USART0_UDRE_vect
__interrupt void USART0_UDRE_interrupt(void)
{
  if (TX_byte_nr < Bytes_to_send)			// M޲ĐBŁA
  {
	UDR0 = (TransmitBuffer[TX_byte_nr++]);	// Mޯ̧Ή޲đM,M޲Ĉʒuw/vis
  }
  else										// M޲ĐBŁA
  {
	UCSR0B &= ~(1<<UDRIE0);					// UDRE荞݋֎~(ޯ̧M)
  }
}
