/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *	ǉLCD֐A۰قް
 *
 * \par Application note:
 *	AVR064: LCDo͕txĎ
 *
 * \par Documentation:
 *	IȺގAxׁ߲A߲אݒAx޲ɂĂreadme.html
 *	B
 *
 * \author
 *	Atmel Corporation: http://www.atmel.com \n
 *	xEҰ: avr@atmel.com
 *
 * $Name: RELEASE_1_1 $
 * $Revision: 1.3 $
 * $RCSfile: LCD_functions.c,v $
 * $Date: 2006/02/16 18:11:22 $  \n
 ******************************************************************************/

// ݸٰ ̧
#include "Main.h"
#include "Lcd_functions.h"
#include "Lcd_driver.h"

// OSϐ
extern unsigned char LCD_displayData[];		// LCD_driver.cŒ`
extern unsigned char TransmitBuffer[50];	// UART.cŒ`
extern unsigned char LCD_Menu1;				// Buttons.cŒ`
extern unsigned char LCD_Menu2;
extern unsigned char LCD_Menu3;

// Ǐϐ
unsigned char String_cnt;		// ۰َɂǂ̕LCDɕ\邩̌o܂ۂ߂̌vƂĎgp
unsigned char Clear_cnt;		// ۰ٌɏXɏ鎞̌vƂĎgp
unsigned char *String;			// LCDɕ\ׂւ̈ʒuwq
unsigned char NumberOfScroll;	// ۰ق̉(vA$FF=JԂ)
unsigned char Colon = FALSE;	// (:)̕\/\w

// "void LCDsetupData(void)"ŎgpLCD\\
unsigned char *String_Table[6] =   {"Clock", "Date", "Setpoint", "Temperature", "Offset", "Contrast"};

// "void LCDwriteData(void)"ŎgpAǂ̌_ON/OFF\
__flash unsigned char BlinkTable[3][6] =
//				   2	   3	   4	   5	   6	   7
//				   ----------------------------------------------
				{{ 1,      1,      0,      0,      0,      0   },
				 { 0,      0,      1,      1,      0,      0   },
				 { 0,      0,      0,      0,      1,      1   }};

// "void LCDwriteData(void)"ŎgpAMޯ̧޲Ĉʒu\
__flash unsigned char DataTable[5][6] =
// ƭ			   2	   3	   4	   5	   6	   7
//				   ----------------------------------------------
// CLOCK		   HOUR    HOUR    MINUTE  MINUTE  SECOND  SECOND
				{{ 7,      8,      10,     11,     13,     14  },
// TEMPERATURE	   DAY     DAY     MONTH   MONTH   YEAR_LO YEAR_LO
				 { 16,     17,     19,     20,     25,     26  },
// SET POINT	   space   space   SETPO.  SETPO.  ---     ---
				 { 6,      6,      28,     29,     0,      0   },
// TEMPERATURE	   TEMP_LO TEMP_LO TEMP_HI TEMP_HI ---     ---
				 { 31,     32,     34,     35,     0,      0   },
// OFFSET		   space   ---     OFFSET  OFFSET  ---     ---
				 { 6,      0,      37,     38,     0,      0   }};

/*! \brief	LCDVް̂߂̏
 */
void LCD_update(void)
{
  if( LCD_status.updateComplete )			// O̍XVŁA
  {
	if( NumberOfScroll )					// ۰ْŁA
	{
	  LCD_status.updateRequired = FALSE;	// XVv׸މ(LCD\ޯ̧XVLCDXVh~p)
	  LCD_AllSegments(FALSE);				// Sď(\)
	  LCDscrollMsg();						// LCD\ޯ̧ɽ۰ٕ쐬
	  LCD_status.updateComplete = FALSE;	// LCDXV׸މ
	  LCD_status.updateRequired = TRUE;		// XVv׸ސݒ(LCD\ޯ̧LCDDRւׯ)
	else									// ۰قȂŁAMޯ̧̓]ڏ
	{
	  if( LCD_Menu1-1 < 5 )					// CONTRAST\ĂȂ΁A
	  {
		LCD_status.updateRequired = FALSE;	// XVv׸މ(LCD\ޯ̧XVLCDXVh~p)
		LCD_SET_COLON(Colon);				// (:)\/\ݒ
		LCDwriteData();						// Mޯ̧LCD\ޯ̧֓]
		LCD_status.updateComplete = FALSE;	// LCDXV׸މ
		LCD_status.updateRequired = TRUE;	// XVv׸ސݒ(LCD\ޯ̧LCDDRւׯ)
	  }
	  else									// CONTRASTƭ\ŁA
		LCD_AllSegments(TRUE);				// Sĕ\
	}
  }
}

/*! \brief	Mޯ̧LCD\ޯ̧֓]
 */
void LCDwriteData(void)
{
  unsigned char LCD_digit_cnt = 8;				// LCDv

  if( ( LCD_Menu1 > 2 ) && ( LCD_Menu1 < 6 ) )	// ƭSet Point,Temperature,Offset\ȂA
  {
	LCD_WriteDigit( 'C' , 7 );					// 7,8Ɂ".C"\
	LCD_WriteDigit( '.' , 6 );

	LCD_digit_cnt = 6;							// LCDv6ɕύX
  }

  while( LCD_digit_cnt > 2 )					// 3ȏŁA
  {
	LCD_digit_cnt--;							// ݌ʒu

	if( LCD_Menu1 > 3 )							// Temperature,Offset\ŁA
	  LCD_status.blinkLCD = FALSE;				// _ŋ֎~

	if( LCD_status.blinkLCD && ( LCD_Menu1 == 3 ) && LCD_Menu2 )	// Set Point\ƭ2L_ŉȂA
	{
	  LCD_WriteDigit( ' ', LCD_digit_cnt );		// Ή󔒓_Őݒ
	}
	else if( LCD_status.blinkLCD && ( BlinkTable[LCD_Menu2-1][LCD_digit_cnt - 2] ) && LCD_Menu2)	// ƭ2Lœ_Ŏw芎_ŉȂA
	{
	  LCD_WriteDigit( ' ', LCD_digit_cnt );		// Ή󔒓_Őݒ
	}
	else										// ̑ŁA
	{
	  if( !(DataTable[LCD_Menu1-1][LCD_digit_cnt - 2]) )	// 󂫌(ΉDataTablel=0)ŁA
	  {
		if(TCCR1A & 0x80)							// M퓮쒆(COM1A1=1)ŁA
		  LCD_WriteDigit( '-' , LCD_digit_cnt );	// Ή'-'ݒ
		else										// p퓮쒆(COM1A1=0)ŁA
		  LCD_WriteDigit( '+' , LCD_digit_cnt );	// Ή'+'ݒ
	  }
	  else										// ް݌ŁAMޯ̧̑ΉlLCD\ޯ̧֓]
		LCD_WriteDigit( TransmitBuffer[DataTable[LCD_Menu1-1][LCD_digit_cnt - 2]] , LCD_digit_cnt );
	}
  }
}

/*! \brief	LCD\ޯ̧֐ݒ肷镶w
 */
void LCDsetupData(void)
{
  if( !LCD_Menu1 )							// ƭ1ŁA
  {
	String_cnt = 0;							// ʒuwq
	String = "STK502 example application for ATmega169";
	NumberOfScroll = 0xFF;					// ۰َw
  }
  else if( !LCD_Menu2 )						// ƭ2ŁA
  {
	NumberOfScroll = 1;						// 1۰َw
	String = String_Table[LCD_Menu1-1];		// ƭΉ擾
	String_cnt = 0;							// ʒuwq
	Colon = TRUE;							// (:)

	if( LCD_Menu1 == 3 | LCD_Menu1 == 5 )	// Set point܂Offset\ŁA
	  Colon = FALSE;						// (:)֎~
  }
  else if( !LCD_Menu3 )						// ƭ3ŁA
  {
	Colon = TRUE;							// (:)
  }
  else										// ƭ3LŁA
  {
	Colon = FALSE;							// (:)֎~
  }
}

/*! \brief	LCD\̽۰ٕ쐬B͂̊֐s閈1ɽ۰ق܂B
 */
void LCDscrollMsg(void)
{
  unsigned char LCD_digit_cnt;			// 86̏LCDʒuwq
  unsigned char Temp;					// Ɨpʒuwq

  if(*(String + String_cnt))			// ΉʒuLŁA(ŏI܂)
  {
	LCD_digit_cnt = 8;					// LCDʒuwq(=ŏIʒu)
	Temp = String_cnt;					// \Jnʒuwq
	while(LCD_digit_cnt > 2)			// LCD8`3
	{
	  LCD_digit_cnt--;					// LCDʒu(0ƂĎgp)
	  if(Temp != 0xFF)					// 擪ȍ~ŁA
		LCD_WriteDigit(*(String + Temp--), LCD_digit_cnt);	// ΉΉɐݒ
	  else								// 擪ȑOŁA
		LCD_WriteDigit( ' ', LCD_digit_cnt );				// Ήɋ󔒐ݒ
	}
	String_cnt++;						// ʒuwqis
	Clear_cnt = (String_cnt + 6);		// ŏI6󔒂܂߂ŏIʒulXV
  }
  else if(Clear_cnt - String_cnt)		// 񏇎ŋԂŁAelse when the whole string has been displayed, make the string fade out
  {                                   // by filling the display with ASCII-space ' '(0x20)
	Clear_cnt--;						// 󔒌v팸
	LCD_digit_cnt = 8;					// LCDʒuwq(=ŏIʒu)
	Temp = 1;							// -ψʌv평
	while(LCD_digit_cnt > 2)			// LCD8`3
	{
	  LCD_digit_cnt--;					// LCDʒu(0ƂĎgp)
	  if( (LCD_digit_cnt - 2) >= (Clear_cnt - String_cnt))	// ΉOŁA
	  {
		LCD_WriteDigit( ' ' , LCD_digit_cnt );		// Ήɋ󔒐ݒ
	  }
	  else													// ΉŁA
	  {
		LCD_WriteDigit( *(String + (String_cnt - Temp)) , LCD_digit_cnt );	// ΉɑΉݒ
		Temp++;							// -ψʌvis
	  }
	}
  }
  else									// 1۰يŁA
  {
	String_cnt = 0;						// ʒu/v평

	if(NumberOfScroll != 0xFF)			// ۰َwłȂ΁A
	  NumberOfScroll--;					// ۰ى񐔌v팸
  }
}
